cmsplugin_news/urls.py
#
# Copyright 2015, Martin Owens <doctormo@gmail.com>
#
# This file is part of the software inkscape-web, consisting of custom
# code for the Inkscape project's django-based website.
#
# inkscape-web is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# inkscape-web is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with inkscape-web.  If not, see <http://www.gnu.org/licenses/>.
#
"""News app which is intergrated into the django-cms system"""

from django.conf.urls import url
from inkscape.url_utils import url_tree

from .feeds import NewsFeed
from .views import (
    ArchiveIndexView, YearArchiveView, MonthArchiveView, DayArchiveView,
    DetailView, DetailNews, UploadMedia,
)

app_name = 'news'

urlpatterns = [ # pylint: disable=invalid-name
    url(r'^$', ArchiveIndexView.as_view(), name='archive_index'),
    url(r'^unpublished/(?P<pk>\d+)/$', DetailNews.as_view(), name="item"),
    url(r'admin/upload/', UploadMedia.as_view(), name='upload'),

    url_tree(
        r'^(?P<year>\d{4})/',
        url(r'^$', YearArchiveView.as_view(), name='archive_year'),
        url_tree(
            r'^(?P<month>\d{2})/',
            url(r'^$', MonthArchiveView.as_view(), name='archive_month'),
            url_tree(
                r'^(?P<day>\d{2})/',
                url(r'^$', DayArchiveView.as_view(), name='archive_day'),
                url(r'^(?P<slug>[-\w]+)/$', DetailView.as_view(), name='detail'),
            ),
        ),
    ),
    url(r'^feed/$', NewsFeed(), name='rss'),
]

cmsplugin_news/templates/cmsplugin_news/base.html
{% extends "base.html" %}
{% load static %}

{% block "css" %}{{ block.super }}
  <link rel="stylesheet" type="text/css" href="{% static "css/news-archive.css" %}"/>
  <link rel="stylesheet" type="text/css" href="{% static "css/news-full.css" %}"/>
{% endblock %}

{% block content %}
  {% block "newscontent" %}{% endblock %}
{% endblock %}

cmsplugin_news/templates/cmsplugin_news/latest_news.html
{% load i18n static %}
<a style="float: right; padding: 5px;" href="{% url "news:rss" %}"><img src="{% static "images/rss.png" %}" alt="{% trans "RSS Feed" %}"/></a>
<a style="float: right; padding: 5px;" href="{{ alert.subscribe_url }}"><img src="{% static "images/email.png" %}" alt="{% trans "Get Email Notifications" %}"/></a>
<div class="cmsplugin-news">
  <div class="content">
{% if latest %}
 {% for news in latest %}
  <div class="article">
    <h2><a href="{{ news.get_absolute_url }}">{{ news.title }}</a></h2>
    <p class="postdate">{{ news.pub_date|date:"DATE_FORMAT" }}</p>
    {{ news.excerpt|safe }}
    <p class="readmore"><a href="{{ news.get_absolute_url }}">{% trans "Read more" %}...</a></p>
  </div>
 {% endfor %}
{% else %}
 <p class="empty">{% trans "No news yet" %}</p>
{% endif %}
<!--<a href="{ url "news:archive_index" %}">{% trans "Archive" %}</a>-->
  </div>
</div>

cmsplugin_news/templates/cmsplugin_news/list_item.html
{% load i18n %}

<div class="article{% if not object.is_published %} unpub{% endif %}">
  <h2><a href="{{ object.get_absolute_url }}">{{ object.title }}</a></h2>
  <div class="postdate">
    {% if object.is_published %}
      {{ object.pub_date }}
    {% else %}
      ({% trans "not published" %})
    {% endif %}
  </div>
  {% if object.excerpt|safe|first == '<' %}
    {{ object.excerpt|safe }}
  {% else %}
    <p>{{ object.excerpt|safe }}</p>
  {% endif %}
  <a class="readmore" href="{{ object.get_absolute_url }}">{% trans "Read more" %}</a>
</div>

cmsplugin_news/templates/cmsplugin_news/news_archive.html
{% extends "cmsplugin_news/base.html" %}
{% load i18n static %}

{% block "newscontent" %}
<a style="float: right; padding: 5px;" href="{% url "news:rss" %}"><img src="{% static "images/rss.png" %}" alt="{% trans "RSS Feed" %}"/></a>
<a style="float: right; padding: 5px;" href="{{ alert.subscribe_url }}"><img src="{% static "images/email.png" %}" alt="{% trans "Get Email Notifications" %}"/></a>

  <div class="pagination">
    <span class="current page">{% trans "News" %}</span>
    {% for date in date_list %}
      <a href="{% url "news:archive_year" year=date|date:'Y'  %}" class="page">{{ date|date:"Y" }}</a>
    {% endfor %}
  </div>

  <h1>{% block title %}{% trans "Latest News" %}{% endblock %}</h1>
  {% for object in latest %}
    {% include "cmsplugin_news/list_item.html" %}
  {% endfor %}
{% endblock %}

cmsplugin_news/templates/cmsplugin_news/news_archive_day.html
{% extends "cmsplugin_news/base.html" %}
{% load i18n %}

{% block "newscontent" %}
  <div class="pagination">
    <a class="current page" href="{% url "news:archive_index" %}">{% trans "News" %}</a>
    <a class="current page" href="{% url "news:archive_year" day.year %}">{{ day.year }}</a>
    <a class="current page" href="{% url "news:archive_month" day.year day|date:'m' %}">{{ day|date:'F' }}</a>
    <span class="current page">{{ day|date:"d" }}</span>
  </div>

  <h1>{% block title %}{% blocktrans %}News for {{ day }}{% endblocktrans %}{% endblock %}</h1>

  {% for object in object_list %}
    {% include "cmsplugin_news/list_item.html" %}
  {% empty %}
    <h2>{% trans "No news for this day." %}</h2>
  {% endfor %}
{% endblock %}

cmsplugin_news/templates/cmsplugin_news/news_archive_month.html
{% extends "cmsplugin_news/base.html" %}
{% load i18n %}

{% block "newscontent" %}
  <div class="pagination">
    <a class="current page" href="{% url "news:archive_index" %}">{% trans "News" %}</a>
    <a class="current page" href="{% url "news:archive_year" month.year %}">{{ month.year }}</a>
    <span class="current page">{{ month|date:'F' }}</span>
    {% for date in date_list %}
      <a href="{% url "news:archive_day" year=month.year month=month|date:'m' day=date|date:'d' %}" class="page">{{ date|date:"d" }}</a>
    {% endfor %}
  </div>

  <h1>{% block title %}{% blocktrans with month|date:'F Y' as month %}News for {{ month }}{% endblocktrans %}{% endblock %}</h1>

  {% for object in object_list %}
    {% include "cmsplugin_news/list_item.html" %}
  {% empty %}
    <h2>{% trans "No news for this month." %}</h2>
  {% endfor %}
{% endblock %}

cmsplugin_news/templates/cmsplugin_news/news_archive_year.html
{% extends "cmsplugin_news/base.html" %}
{% load i18n %}

{% block "newscontent" %}
  <div class="pagination">
    <a class="current page" href="{% url "news:archive_index" %}">{% trans "News" %}</a>
    <span class="current page">{{ year.year }}</span>
    {% for date in date_list %}
      <a href="{% url "news:archive_month" year=year.year month=date|date:'m'  %}" class="page">{{ date|date:"F" }}</a>
    {% endfor %}
  </div>

  <h1>{% block title %}{% blocktrans with year.year as year %}News for {{ year }}{% endblocktrans %}{% endblock %}</h1>
  {% for object in object_list %}
    {% include "cmsplugin_news/list_item.html" %}
  {% empty %}
    <h2>{% trans "No news for this year." %}</h2>
  {% endfor %}
{% endblock %}

cmsplugin_news/templates/cmsplugin_news/news_detail.html
{% extends "cmsplugin_news/base.html" %}

{% load i18n %}

{% block "meta" %}
    <meta name="author" content="{{ object.creator }}" />
    <meta name="description" content="{{ object.excerpt }}" />
{% endblock %}

{% block "precontent" %}
  {% if not object.is_published %}
    <ul id="messages">
        <li class="error" title="{% trans "Use the admin menu to publish it." %}">{% trans "This article is not published yet!" %} (<a href="{{ object.get_live_url }}">{% trans "Live Link" %}</a>)</li>
    </ul>
  {% endif %}
{% endblock %}

{% block "newscontent" %}
  <h1>{% block title %}{{ object.title }}{% endblock %}</h1>
  <p class="postdate">{{ object.pub_date }}</p>
  {{ object.content|safe }}

{% if object.backlinks.count > 0 %}

<hr/>

<div class="backlinks">
  <h5>{% trans "Social Media Posts" %}</h5>
  <div class="social">
    {% for link in object.backlinks.all %}
      {% if link.social_media %}
        <a href="{{ link.url }}"><img src="{{ link.social_media.icon.url }}" title="{{ link.social_media.name }}"/></a>
      {% endif %}
    {% endfor %}
  </div>
  <h5>{% trans "News Backlinks" %}</h5>
  <ul class="links">
    {% for link in object.backlinks.all %}
      {% if not link.social_media %}
        <li><a href="{{ link.url }}">{{ link.url|truncatechars:80 }}</a></li>
      {% endif %}
    {% endfor %}
  </ul>
</div>
{% endif %}

{% endblock %}

cmsplugin_news/templates/cmsplugin_news/newsmedia_ckresponse.html
<html>
<head>
<script type="text/javascript">
  window.parent.CKEDITOR.tools.callFunction("{{ request.GET.CKEditorFuncNum }}", "{{ object.upload.url }}", "");
</script>
</head>
</html>

cmsplugin_news/templates/cmsplugin_news/newsmedia_form.html
<html>
    <head>
        <title>Upload News Media</title>
    </head>
    <body>
        <form method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.errors }}
        {{ form }}
        <input type="submit"/>
        </form>
    </body>
</html>